
class DiGraph:
    def __init__(self):
        self.noeuds = set()
        self.edges = dict()

    def add_edge(self, source, target):
        self.noeuds.add(source)
        self.edges.setdefault(source, set()).add(target)
        self.edges.setdefault(target, set())

    def __len__(self):
        return len(self.noeuds)

    def __iter__(self):
        return iter(self.noeuds)

    def voisin(self, noeud):
        return self.edges[noeud]

    def distance(self, n1, n2):
        vues = set()
        frontiere = {n1}
        d = 1
        while frontiere:
            nouvelle_frontiere = set()
            for x in frontiere:
                if n2 in self.voisin(x):
                    return d
                for y in self.voisin(x):
                    if y not in vues:
                        nouvelle_frontiere.add(y)
            d += 1
            vues.update(frontiere) # ajoute la frontière aux vues
            frontiere = nouvelle_frontiere # nouvelle_frontiere a été calculée
        raise ValueError("Pas de chemin entre n1 et n2")
        # ou 
        return math.inf
        
    def plus_court_chemin(self, n1, n2):
        vues = dict() # chaque noeud est connecté a un noeud de la couche précédante
        frontiere = {n1:None}  
        while frontiere:
            nouvelle_frontiere = dict()
            for x in frontiere:
                for y in self.voisin(x):
                    if y not in vues:
                        nouvelle_frontiere[y] = x
            vues.update(frontiere) # ajoute la frontière aux vues
            if n2 in vues:
                return self.reconstruit_chemin(n1, n2, vues) 
            frontiere = nouvelle_frontiere # nouvelle_frontiere a été calculée
        raise ValueError("Pas de chemin entre n1 et n2")
        # ou 
        return math.inf

    def reconstruit_chemin(self, n1, n2, vues):
        n = n2
        chemin = []
        while n != n1:
            chemin.append(n)
            n = vues[n]
        chemin.append(n1)
        return reversed(chemin)

if __name__ == "__main__":
    G = DiGraph()
    G.add_edge(0, 1)
    G.add_edge(1, 2)
    G.add_edge(2, 0)
    G.add_edge(2, 4)
    G.add_edge(2, 5)
    G.add_edge(4, 6)
    G.add_edge(5, 6)
    print(list(G.plus_court_chemin(0, 6)))
